//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  DarkGray
#property indicator_style3  STYLE_DOT

//
//
//
//
//

extern int    MaPeriod        = 20;
extern int    MaMethod        = MODE_SMA;
extern int    PriceToUse      = PRICE_TYPICAL;
extern int    AtrPeriod       = 50;
extern double AtrMultiplier   = 2.5;
extern int    MaAtrShift      = 1;
extern string MaMethods       = "";
extern string _0              = "0 - SMA";
extern string _1              = "1 - EMA";
extern string _2              = "2 - SMMA";
extern string _3              = "3 - LWMA";

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsOnHighLow = true;
extern bool   alertsOnEachBreak = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";


double bup[];
double bdn[];
double ma[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,bup);
   SetIndexBuffer(1,bdn);
   SetIndexBuffer(2,ma);
   SetIndexBuffer(3,trend);
      IndicatorShortName("Keltner channel ("+MaPeriod+","+DoubleToStr(AtrMultiplier,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i = limit; i >= 0; i--)
      {
         double atr  = iATR(NULL,0,AtrPeriod,i+MaAtrShift);
            ma[i]    = iMA(NULL,0,MaPeriod,0,MaMethod,PriceToUse,i+MaAtrShift);
            bup[i]   = ma[i]+AtrMultiplier*atr;
            bdn[i]   = ma[i]-AtrMultiplier*atr;
            if (alertsOnEachBreak)
                  trend[i] = 0;   
            else  trend[i] = trend[i+1];   
                              
            if (alertsOnHighLow)       
            {
               if (High[i] > bup[i]) trend[i] = -1;
               if (Low[i]  < bdn[i]) trend[i] =  1;
            }
            else
            {
               if (Close[i] > bup[i]) trend[i] = -1;
               if (Close[i] < bdn[i]) trend[i] =  1;
            }
   }
            
   //
   //
   //
   //
   //
               
   if (alertsOn)
   {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] ==  1) doAlert("lower");
            if (trend[whichBar] == -1) doAlert("upper");       
         }            
   }               
   return(0);           
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Keltner price penetrated ",doWhat," channel ");
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Keltner channel "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

//
//
//
//
//


